<?php
//  RChart Visual Builder for PHP
//  Copyright (C) Java4Less.com
//  All rights reserved 
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this (or a modified version) source code is prohibited.
//  - You may not remove this notice from the source code.
//  - This notice disclaim all warranties of all material.
//  - You may not copy and paste any code $o external files.
//  - Use of this software on more than one server
//    requires the appropriate license.

define("NAME_FIELD",0);
define("DESC_FIELD",1);
define("LONG_DESC_FIELD",2);
define("CLASSIFICATION_FIELD",3);
define("DATA_TYPE_FIELD",4);
define("DEFAULT_VAL",5);
define("COMBO_VALUES",6);


class ChartParams {

  // parameter's info
  var $params;
  var $paramCount;

  function ChartParams () {
  	// parameter's info
  	$this->params=Array();
  	$this->paramCount=0;
  }

	function replaceStr($s,$s1,$s2) {
		return	str_replace($s1,$s2,$s);
	}
  
  // load parameter definition
	function loadParameterDefinition() {

		$this->params=Array();
		$this->paramCount=0;

		//$sFile= dirname($_SERVER['SCRIPT_FILENAME']).'/'.'params.txt';
		$sFile= dirname(__FILE__).'/'.'params.txt';
		// open file
		if (!$fc = fopen($sFile,'r')) {  
			  fclose ($fc);
		}
		
      	// read the file and process the contents line by line
         $fileData = fread($fc, filesize($sFile));	
		 
	   // split $o lines
	   $inputLine="";
	   $p=0;
	   $p2=0;
	   while (strlen($fileData)>0) {
	   

	   
	   	$inputLine="";
		$replaceWith="";

		   $p=strpos($fileData,"".chr(13).chr(10));
		   $p2=strpos($fileData,"".chr(10));
		  //echo("a=".$p." ".$p2.chr(13));
		   
		   if (!$p) $p=-1;
		   if (!$p2) $p2=-1;		   
		   
		   if (($p==-1) && ($p2==-1)) {
			   $inputLine=$fileData;
			   $fileData="";		   
		   }else  if (($p<=$p2) && ($p>=0)) {// if line ends with 13 +10
			   $inputLine=substr($fileData,0,$p);
			   $fileData=substr($fileData,$p+2);
		   } else   if (($p==-1) && ($p2>=0)) { // if line ends only with 10
			   $inputLine=substr($fileData,0,$p2);
			   $fileData=substr($fileData,$p2+1);
		   } 
 
		 
            $fields=explode(";",$inputLine);
			
			//echo("name=".$fields[NAME_FIELD]."<BR>");

 
			
		
            $iterations=array("");	
            if ((strpos($fields[NAME_FIELD],"?")!== false)) $iterations=array("X","Y","Y2","X_1","Y_1","Y2_1","X_2","Y_2","Y2_2");
            if ((strpos($fields[NAME_FIELD],"*")!== false)) $iterations=array("1","2","3","4","5","6","7","8","9");
	

			
            for ($i=1;$i<=sizeof($iterations);$i++) {

                        $this->params[]=new ParamInfo();
						
                        $this->params[$this->paramCount]->isSeparator=(substr($fields[NAME_FIELD],0,1)=="_");
                        if (sizeof($fields)>DATA_TYPE_FIELD) $this->params[$this->paramCount]->type=$fields[DATA_TYPE_FIELD];
                        $this->params[$this->paramCount]->value="";
                        $this->params[$this->paramCount]->defaultValue="";

                        //if ($i==1) $replaceWith="X";
                        //if ($i==2) $replaceWith="Y";
                        //if ($i==3) $replaceWith="Y2";
			$replaceWith=$iterations[$i-1];

                        $iStr="".$i;
												
						
                        $this->params[$this->paramCount]->classification=$this->replaceStr($this->replaceStr($fields[CLASSIFICATION_FIELD],"?",$replaceWith),"*",$iStr);

if ((strpos($fields[NAME_FIELD],"*")!== false)) {
		$this->params[$this->paramCount]->isRepeteable=$i;
}
                        
                        $this->params[$this->paramCount]->name=$this->replaceStr($this->replaceStr($fields[NAME_FIELD],"?",$replaceWith),"*",$iStr);
                        $this->params[$this->paramCount]->longDescription=$this->replaceStr($this->replaceStr($fields[LONG_DESC_FIELD],"?",$replaceWith),"*",$iStr);
                        $this->params[$this->paramCount]->shortDescription=$this->replaceStr($this->replaceStr($fields[DESC_FIELD],"?",$replaceWith),"*",$iStr);

                        if (sizeof($fields)>DEFAULT_VAL) {
                            $this->params[$this->paramCount]->defaultValue=$fields[DEFAULT_VAL];
                            $this->params[$this->paramCount]->value=$fields[DEFAULT_VAL];
                        }
						//echo("name=".$this->params[$this->paramCount]->classification."<BR>");

                        // exception, default values
                        if ($this->params[$this->paramCount]->name=="Y2AXIS") {
                           $this->params[$this->paramCount]->value="FALSE";
                           $this->params[$this->paramCount]->defaultValue="FALSE";
                        }
                        if ($this->params[$this->paramCount]->name=="XSCALE_EXACT_MAX") {
                           $this->params[$this->paramCount]->value="FALSE";
                           $this->params[$this->paramCount]->defaultValue="FALSE";
                        }
                        if ($this->params[$this->paramCount]->name=="XSCALE_EXACT_MIN") {
                           $this->params[$this->paramCount]->value="FALSE";
                           $this->params[$this->paramCount]->defaultValue="FALSE";
                        }

                        // there is a list of allowed values
                         if (sizeof($fields)>COMBO_VALUES)
                           if (strlen($fields[COMBO_VALUES])>0)
                             {
                                $this->params[$this->paramCount]->comboValues=explode(",",$fields[COMBO_VALUES]);
                             }

                        $this->paramCount++;
                       
                      } // for
		  } // while
		  

}


  

}
?>