<?php

//  RChart Visual Builder for PHP
//  Copyright (C) Java4Less.com
//  All rights reserved 
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this (or a modified version) source code is prohibited.
//  - You may not remove this notice from the source code.
//  - This notice disclaim all warranties of all material.
//  - You may not copy and paste any code $o external files.
//  - Use of this software on more than one server
//    requires the appropriate license.

require("config.inc");
Require("ParamInfo.inc");

ini_set("include_path", ".");
chdir(RCHARTINCLUDEPATH);


require("chartLoader.inc");
require("Chart.inc");
require("ChartParams.inc");


session_start(); 
header("Cache-control: private"); //IE 6 Fix 


function outputField($pInfo,$value) {
	$s="";
	$tip="onFocus=\"window.status='".$pInfo->longDescription."';return true;\"";
	
	//set default
	if (!isset($value)) $value=$pInfo->defaultValue;
	if ($value=="") $value=$pInfo->defaultValue;

	if (($pInfo->type==PARAM_STRING) || ($pInfo->type==PARAM_CHARTLABEL) ) {
	
		$isCombo=false;
		
		if (is_array($pInfo->comboValues))
			if (sizeof($pInfo->comboValues)>0) $isCombo=true;
	
		if (!$isCombo) 
			$s="<INPUT NAME=".$pInfo->name." ".$tip." size=100 VALUE=\"".$value."\">";
		else {
			$s="<SELECT NAME=".$pInfo->name."  ".$tip." SIZE=1>";
		
			for ($i=0;$i<sizeof($pInfo->comboValues);$i++) {
				$s=$s."<OPTION VALUE=\"".$pInfo->comboValues[$i]."\"  ";
				if ($value==$pInfo->comboValues[$i]) $s=$s." SELECTED ";
				$s=$s.">".$pInfo->comboValues[$i]."</OPTION>";							
			}
		
			$s=$s."</SELECT";
		}
	}

	if ($pInfo->type==PARAM_BOOLEAN) {
		
		$s="<SELECT NAME=".$pInfo->name."  ".$tip." SIZE=1>";
		
		$s=$s."<OPTION VALUE=\"TRUE\"  ";
		if (($value=="Y") || ($value=="YES") || ($value=="TRUE")) $s=$s." SELECTED ";
		$s=$s.">YES</OPTION>";		
		
		$s=$s."<OPTION VALUE=\"FALSE\" ";	
		if (($value=="N") || ($value=="NO") || ($value=="FALSE")) $s=$s." SELECTED ";			
		$s=$s.">NO</OPTION>";		
		
		$s=$s."</SELECT";
	}	

	if ($pInfo->type==PARAM_AXISTARGETZONE) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('axisTargetZoneSelector.html?FIELD=".$pInfo->name."','axistargetzone','resize=no,toolbar=no,width=520,height=280,top=300,left=300')\">";
	}

	if ($pInfo->type==PARAM_TARGETZONE) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('targetZoneSelector.html?FIELD=".$pInfo->name."','targetzone','resize=no,toolbar=no,width=520,height=280,top=300,left=300')\">";
	}

/*	if ($pInfo->type==PARAM_CHARTLABEL) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('labelRenderer.html?FIELD=".$pInfo->name."','labelrendered','resize=no,toolbar=no,width=570,height=450,top=100,left=100')\">";
	}
	*/
	

	if ($pInfo->type==PARAM_LINE) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('lineSelector.html?FIELD=".$pInfo->name."','lineselector','resize=no,toolbar=no,width=300,height=170,top=300,left=300')\">";
	}		
	
	if ($pInfo->type==PARAM_FILL) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('fillingSelector.html?FIELD=".$pInfo->name."','fillingselector','resize=no,toolbar=no,width=350,height=250,top=300,left=300')\"> ";

	}		
	
	if ($pInfo->type==PARAM_COLOR) {	
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('colorSelector.html?FIELD=".$pInfo->name."','colorselector','resize=no,toolbar=no,width=350,height=250,top=300,left=300')\"><font color=\"".$value."\"><b>Color</b></font> ";
	}	
	
	if ($pInfo->type==PARAM_INT) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\">";
	}		
	if ($pInfo->type==PARAM_FONT) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\"><INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('fontSelector.php?FIELD=".$pInfo->name."','fontselector','resize=no,toolbar=no,width=325,height=100,top=300,left=300')\">";
	}	
	if ($pInfo->type==PARAM_DOUBLE) {
		$s="<INPUT NAME=".$pInfo->name." ".$tip." VALUE=\"".$value."\">";
	}		
	
	if ($pInfo->type==PARAM_DOUBLE_LIST) {
		$s="<INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('listEditor.html?FIELD=".$pInfo->name."','listEditor','resize=yes,toolbar=no,width=600,height=500,top=100,left=100')\"><INPUT NAME=".$pInfo->name." ".$tip." size=100  VALUE=\"".$value."\">";
	}		
	
	if ($pInfo->type==PARAM_STRING_LIST) {
		$s="<INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('listEditor.html?FIELD=".$pInfo->name."','listEditor','resize=yes,toolbar=no,width=600,height=500,top=100,left=100')\"><INPUT NAME=".$pInfo->name." ".$tip." size=100  VALUE=\"".$value."\">";
	}				
	
	if ($pInfo->type==PARAM_COLOR_LIST) {
		$s="<INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('listEditor.html?FIELD=".$pInfo->name."','listEditor','resize=yes,toolbar=no,width=600,height=500,top=100,left=100')\"><INPUT NAME=".$pInfo->name." ".$tip." size=100  VALUE=\"".$value."\">";
	}		
	
	if ($pInfo->type==PARAM_BOOLEAN_LIST) {
		$s="<INPUT TYPE=BUTTON value=\"...\" onClick=\"window.open('listEditor.html?FIELD=".$pInfo->name."','listEditor','resize=yes,toolbar=no,width=600,height=500,top=100,left=100')\"><INPUT NAME=".$pInfo->name." ".$tip." size=100  VALUE=\"".$value."\">";
	}	

	return $s;
	
}


$node=$_REQUEST["NODE"];

$save=$_REQUEST["SAVE"];

if (!isset($node)) $node="CHART";
else if ($node=="") $node="CHART";




// load an example
if (array_key_exists( "LOAD", $_REQUEST )) {

	$loader=new ChartLoader();
	$example=$_REQUEST["LOAD"];
	
	if ($example=="16") $loader->loadFromFile(EXAMPLESDIR."linechartClipping.txt",false);
	if ($example=="17") $loader->loadFromFile(EXAMPLESDIR."linechartNULLS.txt",false);
	if ($example=="1") $loader->loadFromFile(EXAMPLESDIR."areaChart_logscale.txt",false);
	if ($example=="2") $loader->loadFromFile(EXAMPLESDIR."barchart.txt",false);
	if ($example=="3") $loader->loadFromFile(EXAMPLESDIR."axisOnTop.txt",false);
	if ($example=="4") $loader->loadFromFile(EXAMPLESDIR."barcumulative.txt",false);
	if ($example=="5") $loader->loadFromFile(EXAMPLESDIR."piechart.txt",false);
	if ($example=="6") $loader->loadFromFile(EXAMPLESDIR."radarChart.txt",false);
	if ($example=="7") $loader->loadFromFile(EXAMPLESDIR."linechart3D.txt",false);
	if ($example=="8") $loader->loadFromFile(EXAMPLESDIR."bar3d.txt",false);
	if ($example=="9") $loader->loadFromFile(EXAMPLESDIR."scatterChart.txt",false);
	if ($example=="10") $loader->loadFromFile(EXAMPLESDIR."curves.txt",false);
	if ($example=="11") $loader->loadFromFile(EXAMPLESDIR."combinedChart.txt",false);		
	if ($example=="12") $loader->loadFromFile(EXAMPLESDIR."gauge.txt",false);		
	if ($example=="13") $loader->loadFromFile(EXAMPLESDIR."eventChart_dates.txt",false);				
	if ($example=="14") $loader->loadFromFile(EXAMPLESDIR."candlestick.txt",false);				
	if ($example=="15") $loader->loadFromFile(EXAMPLESDIR."bubble.txt",false);				
if ($example=="19") $loader->loadFromFile(EXAMPLESDIR."bubble.txt",false);
if ($example=="20") $loader->loadFromFile(EXAMPLESDIR."areaChart.txt",false);
if ($example=="21") $loader->loadFromFile(EXAMPLESDIR."targetZones.txt",false);
if ($example=="22") $loader->loadFromFile(EXAMPLESDIR."patternFilling.txt",false);
if ($example=="23") $loader->loadFromFile(EXAMPLESDIR."MultiAxis.txt",false);
if ($example=="24") $loader->loadFromFile(EXAMPLESDIR."StackedMultiAxis.txt",false);
if ($example=="25") $loader->loadFromFile(EXAMPLESDIR."MultiCharts.txt",false);
if ($example=="26") $loader->loadFromFile(EXAMPLESDIR."combined2Positions.txt",false);
if ($example=="27") $loader->loadFromFile(EXAMPLESDIR."barImages.txt",false);
if ($example=="28") $loader->loadFromFile(EXAMPLESDIR."areaChartLog.txt",false);
if ($example=="29") $loader->loadFromFile(EXAMPLESDIR."areaChartLog2.txt",false);
if ($example=="30") $loader->loadFromFile(EXAMPLESDIR."areaChart_tips.txt",false);
if ($example=="31") $loader->loadFromFile(EXAMPLESDIR."piechart.txt",false);
if ($example=="32") $loader->loadFromFile(EXAMPLESDIR."piechart2D.txt",false);

	$_SESSION['chartloader']=& $loader;
	
	$node="CHART";	
}



$loader=$_SESSION['chartloader']; 

// create a new chart
if ($node=="NEW") {
	$loader=new ChartLoader();
	$node="CHART";
	$_SESSION['chartloader']=& $loader;
}

if (!isset($loader)) {
	$loader=new ChartLoader();
	// load first example
	$loader->loadFromFile(EXAMPLESDIR."curves.txt",false);
	$_SESSION['chartloader']=& $loader;
}

if ($save=="1") {

	// save parameters we receive now to the chartLoader
	$keys = array_keys( $_REQUEST);
	for ($i=0;$i<sizeof($keys);$i++) {
	
		$v=$_REQUEST[$keys[$i]];
		$v=str_replace("\\\\n","\\n",$v);
		$v=str_replace("\'","'",$v);
	
		$loader->setParameter($keys[$i],$v);		
	}	
	$_SESSION['chartloader']=& $loader;
}

$params=new ChartParams();
$params->loadParameterDefinition();

echo("<html>");
echo("<body>");
echo("<FORM name=\"paramform\" METHOD=POST ACTION=\"params.php?SAVE=1&NODE=".$node."\" target=\"_self\" >");
//echo("<FORM name=\"paramform\" METHOD=POST ACTION=\"\" target=\"_self\" >");
echo("<table width=\"100%\" border=\"0\" cellspacing=\"0\" >");

// submit button
echo("<tr>");	
echo("<td valign=\"top\" width=\"300px\"><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\"><INPUT TYPE=SUBMIT value=\"Save\"><INPUT TYPE=BUTTON value=\"Refresh\" onClick=\"parent.frames['area'].location.reload();return true;\"></font></td>");
//echo("<td valign=\"top\" width=\"300px\"><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\"><INPUT TYPE=BUTTON value=\"Save\" onClick=\"alert('RChart Visual Builder is in read only mode. Contact java4less@confluencia.net for more information.')\"><INPUT TYPE=BUTTON value=\"Refresh\" onClick=\"parent.frames['area'].location.reload();return true;\"></font></td>"); 
echo("<td valign=\"top\" ><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\"></font></td>");	
echo("</tr>");

$index=0;

for ($i=1;$i<=9;$i++)
	if ($node=="SERIE".$i) {
		$node="SERIE";
		$index=$i;
	}
for ($i=1;$i<=5;$i++)
	if ($node=="NOTE".$i) {
		$node="NOTE";
		$index=$i;
	}
for ($i=1;$i<=5;$i++)
	if ($node=="TARGETZONE".$i) {
		$node="TARGETZONE";
		$index=$i;
	}



$backColor="#FFFFFF"; // bgcolor="#003366"
for ($i=0;$i<$params->paramCount;$i++) {
	$addThisParam=false;


	if (($index==$params->params[$i]->isRepeteable) && (strtoupper($params->params[$i]->classification)==strtoupper($node))) $addThisParam=true;
			
	if (($params->params[$i]->isRepeteable==0) && ($index<=0))
				if (strtoupper($params->params[$i]->classification)==strtoupper($node))  $addThisParam=true;



	if ($addThisParam) {

	
	// onMouseOver="tip(this,event,'tips')   onMouseout=hidetip()"
	if (substr($params->params[$i]->name,0,1)=="_") {
		// separator
	
		echo("<tr bgcolor=\"#3300CC\" >");
		echo("<td  valign=\"top\" width=\"300px\"><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\" color=\"#FFFFFF\" >".$params->params[$i]->shortDescription."</font></td>");
		echo("<td  valign=\"top\" ></td>");
		$backColor="#EEEEEE";
	}
	else {
		echo("<tr bgcolor=\"".$backColor."\" >");
		
		$hasValue=false;
		$value=$loader->getParameter($params->params[$i]->name,"");
		
		if ($value!="") {
			if ($value!=$params->params[$i]->defaultValue) $hasValue=true;
		}
		
		if ($hasValue)
			echo("<td  valign=\"top\" width=\"300px\"><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\">".$params->params[$i]->shortDescription."</font></td>");
		else
			echo("<td  valign=\"top\" width=\"300px\"><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\" color=\"#BBBBBB\" >".$params->params[$i]->shortDescription."</font></td>");			
		echo("<td  valign=\"top\" ><font size=\"-1\" face=\"Arial, Helvetica, sans-serif\">".outputField($params->params[$i],$value)."</font></td>");
	}
	
	echo("</tr>");
	
	if ($backColor=="#FFFFFF") $backColor="#EEEEEE";
	else $backColor="#FFFFFF";
	
	}
	
	
	
}


echo("</table>");
echo("<INPUT TYPE=\"HIDDEN\" NAME=\"NODE\" VALUE=\"".$_REQUEST["NODE"]."\">");
echo("</FORM>");


echo("</body>");
echo("</html>");




?>